#!/usr/bin/perl

###############################################################################
#                                                                             #
#               Umfrage V2.1 - Statistik                                      #
#                                                                             #
#               All rights reserved.                                          #
#               Copyright (C) 2004 Dipl.-Ing. Markus Robert Keler            #
#               Bad Schussenried, Germany                                     #
#                                                                             #
#               Aktualisierungen unter http://developer.dipl-ing-kessler.de   #
#                                                                             #
###############################################################################
#                                                                             #
#               Einsatz:                                                      #
#               Abstimm- und Auswerteprogramm fr Statistikzwecke             #
#                                                                             #
###############################################################################

@auswahl_name  = ("Mglichkeit 1" , "Mglichkeit 2" , "Mglichkeit 3" , "Mglichkeit 4");
@balkendatei   = ("gruen.gif      , "blau.gif"      , "blau.gif"      , "rot.gif"     );
$datei_ort     = "/images";                 # Relativ zu Apache Document Root #
$vertikal      = 'ja';          # Abstimm-Auswahl unter- oder nebeneinander ? #
$abst_ja_nein  = 'ja';    # Einblenden der Abstimmflchen, Stimmabgabe mgl.? #
$sperre_ip     = 'nein';
$sperre_cookie = 'ja';

$cookie_name   = 'Name';
$cookie_value  = 'abgestimmt';
$exp_date      =  '23-Apr-04 23:59:59 GMT';

$ueberschrift  = "- Umfrage zum Zitate-Verteiler -";
$titel         = "Umfrage V2.1";
$umfrage       = "Was nehmen wir - Mglichkeit 1, 2, 3 oder 4?";
$abgabe        = "23.04.2004";
$erg_datei     = "/kompletter/pfad/zu/cgi-bin/umfrage1.txt";
$backgnd       = "/backgnd/winvi13.jpg";

$format_tab    = "<font face=\"Arial, Helvetica\" size=3 color=Purple><b>";
$format_ueb    = "<font face=\"Arial, Helvetica\" size=5 color=Maroon><b>";
$format_frage  = "<font face=\"Arial, Helvetica\" size=5 color=Red><b>";
$format_fehler = "<font face=\"Arial, Helvetica\" size=6 color=White><b>";
$format_std    = "<font face=\"Arial, Helvetica\" size=3 color=Purple><b>";

$faktor        = '0.5';           # An Breite der Balken-Gif-Dateien anpassen #

### Bitte ab hier nichts mehr ndern ##########################################

# Get the input
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
# Split the name-value pairs
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
   ($name, $value) = split(/=/, $pair);
   # Un-Webify plus signs and %-encoding
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<!--(.|\n)*-->//g;
   $FORM{$name} = $value;
}

$flag= ($FORM{'Meinung'} eq '' ? '0' : '1'); # Skriptum mit Parameter aufgerufen? #

$ip_aktuell   = $ENV{'REMOTE_ADDR'};

open(ErgebnisDatei,$erg_datei) or die "Couldn't open $to_file: $!\n";
for ($i=0; $i < @auswahl_name; $i++) {
   $auswahl_anzahl[$i]=<ErgebnisDatei>;       # @auswahl_anzahl: Stimme fr jeweilige Auswahl #
   chomp($auswahl_anzahl[$i]);
}
$ip_alt = <ErgebnisDatei>; chomp($ip_alt);
close(ErgebnisDatei);

if ($flag eq '1') {                        # Skriptum mit Parameter aufgerufen? #
   if ( ($ip_aktuell eq $ip_alt && $sperre_ip eq 'ja') ||
        (index($ENV{'HTTP_COOKIE'},$cookie_value) ne -1 && $sperre_cookie eq 'ja') ) {
      print "Content-Type: text/html\n\n";
      print "<html>\n<head>\n<title>$titel - Reload-Sperre</title>\n</head>\n";
      print "<body background=$backgnd>\n";
      print "<table width=100\% height=100\%><tr><td align=center valign=middle><br>\n";
      print "<table width=400 height=300 border=10 bgcolor=Red>\n";
      print "<tr><td align=center valign=middle>$format_fehler\n";
      print "- Reload-Sperre -<p>\n";
      print "Bitte pro Person<br>nur 1x abstimmen!<p>- Danke -\n";
      print "</td></tr>\n";
      print "</table>\n";
      print "</td></tr></table>\n";
      print "</body></html>\n";
      exit;
   }
   else {
      if($sperre_cookie eq 'ja') {
         print "Set-Cookie: $cookie_name=$cookie_value; expires=$exp_date\n";
      }
      open(ErgebnisDatei,">$erg_datei") or die "Couldn't open $erg_datei: $!\n";
      for ($i=0; $i < @auswahl_name; $i++) {
         if ($FORM{'Meinung'} eq $i) {
            $auswahl_anzahl[$i]++;
         }
      }
      for ($i=0; $i < @auswahl_name; $i++) {
         printf ErgebnisDatei "$auswahl_anzahl[$i]\n";
      }
      printf ErgebnisDatei "$ip_aktuell\n";
      close(ErgebnisDatei);
   }
}

$summe='0';
for ($i=0; $i < @auswahl_name; $i++) {
   $summe += $auswahl_anzahl[$i];
}

for ($i=0; $i < @auswahl_name; $i++) {
   if ($summe > '0') {
      $auswahl_anzahl_prozent[$i] = int ( 0.5 + (10000*$auswahl_anzahl[$i]/$summe)) / 100;
      $balkenlaenge[$i]           = int (0.5 + ( $auswahl_anzahl_prozent[$i] * $faktor));
   }
   else {
      $auswahl_anzahl_prozent[$i] = '0';
      $balkenlaenge[$i]           = '0';
   }
}

print "Content-Type: text/html\n\n";
print "<html>\n<head>\n<title>$titel - Auswertung</title>\n</head>\n";
print "<body background=$backgnd>\n";
print "<center>\n";

print "<table width=100\%><tr><td bgcolor=\"\#cc9900\" align=center>\n";
print "$format_ueb";
print "$ueberschrift\n";
print "</table>\n";
print "<br>$format_std";
print "Auswertung der bisherigen Abstimm-Ergebnisse:<p>\n";

print "<table border=5><tr><td>\n";
print "<table border=0>\n";
print "<tr><td height=5> </td></tr>\n";
print "<tr><td> </td><td>$format_tab Auswertung prozentual:</td></tr>\n";

for ($i=0; $i < @auswahl_name; $i++) {
   print "<tr><td>$format_tab $auswahl_name[$i]:</td>\n";
   print "<td>\n";
   print "<img src=$datei_ort/null.gif>";
   for ($zaehler=0 ; $zaehler<$balkenlaenge[$i] ; $zaehler++) {
      print "<img src=$datei_ort/$balkendatei[$i]>";
   }
   $ausgabe = sprintf ("%.02f", $auswahl_anzahl_prozent[$i]);
   print "$format_tab $ausgabe \%";
   print "</td></tr>\n";
}

print "<tr><td height=10> </td></tr>\n";

print "<tr><td> </td><td>$format_tab Auswertung absolut:</td></tr>\n";

for ($i=0; $i < @auswahl_name; $i++) {
   print "<tr><td>$format_tab $auswahl_name[$i]:</td>\n";
   print "<td><img src=$datei_ort/null.gif>$format_tab $auswahl_anzahl[$i]</td></tr>\n";
}

print "<tr><td>$format_tab Summe:</td>\n";
print "<td><img src=$datei_ort/null.gif>$format_tab $summe</td></tr>\n";

print "<tr><td height=10> </td></tr>\n";

print "</table>\n";
print "</td></tr></table>\n";

print "<p>\n";

print "$format_frage\n";
print "Frage: $umfrage<br>\n";

print "$format_std<br>\n";
print "Bitte abstimmen bis einschlie\&szlig\;lich $abgabe:<p>\n";

if($abst_ja_nein eq 'ja') {
   print "<form method=POST action=\"$ENV{'SCRIPT_NAME'}\">\n";
   for ($i=0; $i < @auswahl_name; $i++) {
      print "<input type=\"radio\" name=\"Meinung\"";
      if($i eq '0') {
         print " checked ";
      }
      print "value=\"$i\">$auswahl_name[$i] ";
      if($vertikal eq 'ja') {
         print "<p>";
      }
   }
   print "<p>";
   print "<input type=\"submit\" value=\"   Abstimmen   \">\n";
   print "</form>\n";
}
else {
   print "$format_frage\n";
   print "Keine Stimmabgabe mehr m\&ouml\;glich.<br>\n";
   print "Danke f\&uuml\;r $summe Stimmen!\n";
}

print "</body>\n</html>\n";

exit;

